#ifndef RELEVANT_TAV_VALS
#define RELEVANT_TAV_VALS

void get_tav_range(unsigned long int * low_tav_val,unsigned long int * high_tav_val, unsigned long int n, long double theTresh, ListNode* SENT_tav_vect, mp_rnd_t ROUND_MODE,mp_prec_t MY_PREC);

#endif

void get_tav_range(unsigned long int * low_tav_val,unsigned long int * high_tav_val, unsigned long int n, long double theTresh, ListNode* SENT_tav_vect, mp_rnd_t ROUND_MODE,mp_prec_t MY_PREC)
{
  int i,maxAti,left_i,right_i;
  unsigned long int temp_ui_i;
  long double a_val,sumUp,maxVal;
  long double theVals[n];

  ListNode* Mpfr_tav_vect=SENT_tav_vect;
  ListNode* temp_node=NULL;
  mpfr_t* an_mpfr_ptr=NULL;
  maxVal=0;
  maxAti=0;
  for (i=0;i<n;i++)
    {
      temp_ui_i=i+1;
      temp_node=Mpfr_tav_vect->GetBetaAlphaNode(Mpfr_tav_vect,n,temp_ui_i);
      an_mpfr_ptr=temp_node->GetMpfr();
      a_val=mpfr_get_ld(*an_mpfr_ptr,ROUND_MODE);
      if (a_val>maxVal)
       {
	maxVal=a_val;
	maxAti=i;
       }
      theVals[i]=a_val;
      temp_node=NULL;
      an_mpfr_ptr=NULL;
    }
  sumUp=maxVal;
  right_i=maxAti;
  left_i=maxAti;
  *low_tav_val=(maxAti+1);
  *high_tav_val=(maxAti+1);

  for (i=0;i<n;i++)
    {
      if (sumUp<(1.0-theTresh))
	{
 	  right_i++;
	  left_i--;
	  if (left_i>=0)
	    {
	      sumUp=sumUp+theVals[left_i];
              *low_tav_val=(left_i+1);
	      //cout<<"left "<<left_i+1<<" "<<sumUp<<"\n";
	    }
	  if (right_i<n)
	    {
	      sumUp=sumUp+theVals[right_i];
              *high_tav_val=(right_i+1);
	      //cout<<"right "<<right_i+1<<" "<<sumUp<<"\n";
	    }
	}
    }
  //for (i=0;i<n;i++)
  //  {
  //    cout<<i+1<<" "<<theVals[i]<<"\n";
  //  }
  //cout<<"maxVal "<<maxVal<<"\n";
  //cout<<"maxAti "<<maxAti<<"\n";
  //cout.precision(20);
  //cout<<"Sumup "<<sumUp<<"\n";
  //cout<<"low tav val "<<*low_tav_val<<"\n";
  //cout<<"high tav val "<<*high_tav_val<<"\n";
//  *low_tav_val=1;
 // *high_tav_val=n-1;
}


